#include <qapp.h>
#include <qobject.h>
#include <qlabel.h>
#include <qbttngrp.h>
#include <qpushbt.h>
#include <qlcdnum.h>
#include "cdctl.h"

QApplication *mapp;
QLabel *pmatrix1;
QLCDNumber *ptime2;
QPushButton *ppb[11];
QLabel *sicon[4];
QPalette *p0pal,*p1pal;
CDCtl *cdctl;
int siconon=-1;

class MSignals : public QObject
{
   Q_OBJECT
public:
   MSignals(){
      TID1=startTimer(200);
   }
   ~MSignals(){
      killTimer(TID1);
   }
public slots:
   void btnGroupClicked(int id){
      if(ppb[id]->isEnabled()==FALSE)
         return;
      switch (id)
      {
       case 0:
          cdctl->btnStop();
       break;
       case 1:
          cdctl->btnPause();
       break;
       case 2:
	  cdctl->btnPlay();
       break;
       case 3:
          cdctl->btnPrev();
       break;
       case 4:
	  cdctl->btnPlay();
       break;
       case 5:
          cdctl->btnNext();
       break;
       case 6:
          cdctl->btnRewd();
       break;
       case 7:
          cdctl->btnEject();
       break;
       case 8:
          cdctl->btnFfwd();
       break;
       case 9:
          mapp->mainWidget()->iconify();
       break;
       case 10:
          mapp->quit();
       break;
       redisplay();
      }
   }
protected:
   void timerEvent(QTimerEvent *te){
      if(te->timerId()==TID1){
         cdctl->status();
         redisplay();
      }
   }
   void redisplay(){
         /* update display of which track is playing */
         char msg[40]="";
         int siconnew=0;
         int cur_cdmode=cdctl->cdstat->cdmode;
         int cur_track=cdctl->cdstat->track;
         int cur_remain=cdctl->cdstat->remain;
	 switch (cur_cdmode)
         {
	  case 0:
             siconnew=0;
             ptime2->display("00:00");
             if(cdctl->cdstat->datatrk)
                sprintf(msg,"Data Track");
             else
	        sprintf (msg,"Track %02d", cur_track);
	  break;
	  case 1:
             if(cur_remain<30*75)
                sprintf (msg,"  -%02d",cur_remain/75);
             else
	        sprintf (msg,"%02d:%02d",cdctl->cdstat->pos_rel/60,cdctl->cdstat->pos_rel%60);
	     ptime2->display(msg);
	     sprintf (msg,"Track %02d", cur_track);
             siconnew=2;
	  break;
	  case 3:
             if(cur_remain<30*75)
                sprintf (msg,"  -%02d",cur_remain/75);
             else
	        sprintf (msg,"%02d:%02d",cdctl->cdstat->pos_rel/60,cdctl->cdstat->pos_rel%60);
	     ptime2->display(msg);
	     sprintf (msg,"Track %02d", cur_track);
             siconnew=1;
	  break;
	  case 4:
             ptime2->display("00:00");
             if(cdctl->cdstat->datatrk)
                sprintf(msg,"Data Track");
             else
	        sprintf (msg,"Track %02d", cur_track);
             siconnew=0;
	  break;
	  case 5:
             ptime2->display("00:00");
             if(cdctl->cdstat->trayopen)
                sprintf (msg,"Tray Open");
             else
	        sprintf (msg,"No Disc");
             siconnew=3;
          break;
	  default:
	     sprintf (msg,"CDMODE   %02d", cur_cdmode);
	 }
         if(siconon!=siconnew){
            if(siconon>-1)
               sicon[siconon]->setPalette(*p0pal);
            sicon[siconnew]->setPalette(*p1pal);
            ppb[0]->setEnabled((cur_cdmode==CDPLAY) || (cur_cdmode==CDPAUZ));
            ppb[1]->setEnabled((cur_cdmode==CDPLAY) || (cur_cdmode==CDPAUZ));
            ppb[3]->setEnabled(cur_cdmode!=CDPAUZ && cur_cdmode!=CDEJECT);
            ppb[4]->setEnabled(cur_cdmode==CDPLAY);
            ppb[5]->setEnabled(cur_cdmode!=CDPAUZ && cur_cdmode!=CDEJECT);
            ppb[6]->setEnabled(cur_cdmode==CDPLAY);
            ppb[8]->setEnabled(cur_cdmode==CDPLAY);
            siconon=siconnew;
	 }
         ppb[2]->setEnabled(((cur_cdmode==CDSTOP) || (cur_cdmode==CDNULL)) && !(cdctl->cdstat->datatrk));
         pmatrix1->setText(msg);
   }
private:
   int TID1;
};















